# Kickstart config file generated by Spacewalk Config Management
# Profile Label : rhel_c_5_32
# Date Created  : 2010-09-01 08:13:10.0

install
text
network --bootproto dhcp --hostname=linuxinstall
url --url http://spacewalk/ks/dist/rhel-client-5.5-i386
lang en_US
keyboard de-latin1-nodeadkeys
zerombr 
clearpart --all
bootloader --location mbr
timezone Europe/Berlin
auth --enablemd5 --enableshadow --enablenis --nisdomain=mynisdomain --nisserver=0.0.0.0
rootpw --iscrypted $<dummy>
selinux --disabled
reboot
firewall --enabled --ssh --port=4545 --trust=eth0
xconfig --defaultdesktop=GNOME --startxonboot
repo --name=VT --baseurl=http://spacewalk/ks/dist/rhel-client-5.5-i386/VT
repo --name=Workstation --baseurl=http://spacewalk/ks/dist/rhel-client-5.5-i386/Workstation
key --skip
autopart
graphical
logging --level=debug
repo --name=rhel_client_5.5_i386_vt --baseurl=http://spacewalk/ks/dist/child/rhel_client_5.5_i386_vt/rhel-client-5.5-i386
repo --name=rhel_client_5.5_i386_workstation --baseurl=http://spacewalk/ks/dist/child/rhel_client_5.5_i386_workstation/rhel-client-5.5-i386
repo --name=rhel_client_5.5_i386_client --baseurl=http://spacewalk/ks/dist/child/rhel_client_5.5_i386_client/rhel-client-5.5-i386

%packages 

@gnome-desktop
@development-tools
@admin-tools
@base-x
@system-tools
@x-software-development
@graphics
@sound-and-video
@development-libs
@base
@gnome-software-development
@graphical-internet
@kde-desktop
@authoring-and-publishing
@eclipse
@kde-software-development
@java-development
@office
@ruby
@java
@legacy-software-development
@legacy-software-support
@games
@engineering-and-scientific
@text-internet
@editors

%pre

wget "http://spacewalk/cblr/svc/op/trig/mode/pre/profile/rhel_c_5_32:1:SpacewalkDefaultOrganization" -O /dev/null


%pre
echo "Saving RHN keys..." > /dev/ttyS0
SYSTEM_ID=/etc/sysconfig/rhn/systemid
rhn_keys_found=no

insmod /lib/jbd.o
insmod /lib/ext3.o

mkdir -p /tmp/rhn

drives=$(list-harddrives | awk '{print $1}')
for disk in $drives; do
    DISKS="$DISKS $(fdisk -l /dev/$disk | awk '/^\/dev/{print $1}')"
done

# Try to find the keys on ordinary partitions
for disk in $DISKS; do
    name=test-$(basename $disk)
    mkdir -p /tmp/$name
    mount $disk /tmp/$name
    [ $? -eq 0 ] || continue # Skip to the next partition if the mount fails

    # Copy current RHN host keys out to be reused
    if [ -f /tmp/${name}$SYSTEM_ID ]; then
        cp -a /tmp/${name}$SYSTEM_ID /tmp/rhn
        rhn_keys_found="yes"
        umount /tmp/$name
        break
    fi
    umount /tmp/$name
    rm -r /tmp/$name
done

# Try LVM if that didn't work
if [ "$rhn_keys_found" = "no" ]; then
    lvm lvmdiskscan
    vgs=$(lvm vgs | tail -n +2 | awk '{ print $1 }')
    for vg in $vgs; do
        # Activate any VG we found
        lvm vgchange -ay $vg
    done
    
    lvs=$(lvm lvs | tail -n +2 | awk '{ print "/dev/" $2 "/" $1 }')
    for lv in $lvs; do
        tmpdir=$(mktemp -d findkeys.XXXXXX)
        mkdir -p /tmp/${tmpdir}
        mount $lv /tmp/${tmpdir} || continue # Skip to next volume if this fails

        # Let's see if the keys are in there
        if [ -f /tmp/${tmpdir}$SYSTEM_ID ]; then
            cp -a /tmp/${tmpdir}$SYSTEM_ID /tmp/rhn/
            rhn_keys_found="yes"
            umount /tmp/${tmpdir}
            break # We're done!
        fi
        umount /tmp/${tmpdir}
        rm -r /tmp/${tmpdir}
    done
    
    # And clean up..
    for vg in $vgs; do
        lvm vgchange -an $vg
    done
fi

# Loop until the RHN rpm is installed
if [ "$rhn_keys_found" = "yes" ]; then
    while : ; do
        sleep 10
        if [ -d /mnt/sysimage/root ] ; then
            cp -af /tmp/rhn/* /mnt/sysimage/root/systemid.old
            break
        fi
    done &
fi



%post --nochroot
mkdir /mnt/sysimage/tmp/ks-tree-copy
if [ -d /oldtmp/ks-tree-shadow ]; then
cp -fa /oldtmp/ks-tree-shadow/* /mnt/sysimage/tmp/ks-tree-copy
elif [ -d /tmp/ks-tree-shadow ]; then
cp -fa /tmp/ks-tree-shadow/* /mnt/sysimage/tmp/ks-tree-copy
fi
cp /etc/resolv.conf /mnt/sysimage/etc/resolv.conf
cp -f /tmp/ks-pre.log* /mnt/sysimage/root/
cp `awk '{ if ($1 ~ /%include/) {print $2}}' /tmp/ks.cfg` /tmp/ks.cfg /mnt/sysimage/root

%post --interpreter /usr/bin/python
import xmlrpclib
import os
import os.path
system_id = "/root/systemid.old"
try:

    new_keys = "1-521bc7913170c7b53178dc987cb4a028,1-3d43dca756baefe64cdf6b36de87f1de,1-33717af9811ad2f01e30405da9af1ecb"
    for key in new_keys.split(','):
        if key.startswith('re-'):
            os.exit(0)
    if os.path.exists(system_id):
        client =  xmlrpclib.Server("http://spacewalk/rpc/api")
        key = client.system.obtain_reactivation_key(open(system_id).read())
        f = open("/tmp/key","w")
        f.write(key)
        f.close()
except:
    # xml rpc due to  a old/bad system id
    # we don't care about those
    # we'll register those as new. 
    pass


%post --logfile /mnt/sysimage/root/ks-rhn-post.log
# --Begin Spacewalk command section--
cat > /tmp/ssl-key-1 <<'EOF'
Certificate:
    Data:
        <REMOVED>
        
-----END CERTIFICATE-----

EOF
# ssl-key1
cat /tmp/ssl-key-* > /usr/share/rhn/RHN-ORG-TRUSTED-SSL-CERT
perl -npe 's/RHNS-CA-CERT/RHN-ORG-TRUSTED-SSL-CERT/g' -i /etc/sysconfig/rhn/*

mkdir -p /tmp/rhn_rpms/optional
cd /tmp/rhn_rpms/optional 
wget -P /tmp/rhn_rpms/optional http://spacewalk/download/package/26ea536caf380e97133bd4aa0df93c32cc4468f1/0/1/5050/libxml2-python-2.6.26-2.1.2.8.i386.rpm http://spacewalk/download/package/5708c3fcd9440623edfce3d61801d1e6400baf0f/0/1/17665/rhnlib-2.5.26-1.el5.noarch.rpm http://spacewalk/download/package/52ea4ef59d645eff383252382bdd76d17e400cdd/0/1/5610/pyOpenSSL-0.6-1.p24.7.2.2.i386.rpm 
rpm -Uvh --replacepkgs --replacefiles /tmp/rhn_rpms/optional/pyOpenSSL* /tmp/rhn_rpms/optional/rhnlib* /tmp/rhn_rpms/optional/libxml2-python* 
perl -npe 's|^(\s*serverURL\s*=\s*[^:]+://)[^/]*/|${1}spacewalk/|' -i /etc/sysconfig/rhn/up2date
mkdir -p /etc/sysconfig/rhn/allowed-actions/script
touch /etc/sysconfig/rhn/allowed-actions/script/all
mkdir -p /etc/sysconfig/rhn/allowed-actions/configfiles
touch /etc/sysconfig/rhn/allowed-actions/configfiles/all

# now copy from the ks-tree we saved in the non-chroot checkout
cp -fav /tmp/ks-tree-copy/* /
rm -Rf /tmp/ks-tree-copy
# --End Spacewalk command section--

/etc/init.d/messagebus restart
/etc/init.d/haldaemon restart
# begin cobbler snippet
# begin Red Hat management server registration
mkdir -p /usr/share/rhn/
wget http://spacewalk/pub/RHN-ORG-TRUSTED-SSL-CERT -O /usr/share/rhn/RHN-ORG-TRUSTED-SSL-CERT   
perl -npe 's/RHNS-CA-CERT/RHN-ORG-TRUSTED-SSL-CERT/g' -i /etc/sysconfig/rhn/*  
key=""
if [ -f /tmp/key ]; then
    key=`cat /tmp/key`
fi

if [ $key ]; then 
    rhnreg_ks --serverUrl=https://spacewalk/XMLRPC --sslCACert=/usr/share/rhn/RHN-ORG-TRUSTED-SSL-CERT --activationkey=$key,1-521bc7913170c7b53178dc987cb4a028,1-3d43dca756baefe64cdf6b36de87f1de,1-33717af9811ad2f01e30405da9af1ecb
else
     rhnreg_ks --serverUrl=https://spacewalk/XMLRPC --sslCACert=/usr/share/rhn/RHN-ORG-TRUSTED-SSL-CERT --activationkey=1-521bc7913170c7b53178dc987cb4a028,1-3d43dca756baefe64cdf6b36de87f1de,1-33717af9811ad2f01e30405da9af1ecb
fi
# end Red Hat management server registration

# end cobbler snippet

rhn_check

# Start post_install_network_config generated code
# End post_install_network_config generated code



%post# Start post install kernel options update
/sbin/grubby --update-kernel=`/sbin/grubby --default-kernel` --args="nousbstorage= noapic= "
# End post install kernel options update



# Start koan environment setup
echo "export COBBLER_SERVER=spacewalk" > /etc/profile.d/cobbler.sh
echo "setenv COBBLER_SERVER spacewalk" > /etc/profile.d/cobbler.csh
# End koan environment setup

# MOTD
echo >> /etc/motd
echo "Spacewalk kickstart on $(date +'%Y-%m-%d')" >> /etc/motd
echo >> /etc/motd

# end of generated kickstart file

wget "http://spacewalk/cblr/svc/op/ks/profile/rhel_c_5_32:1:SpacewalkDefaultOrganization" -O /root/cobbler.ks
wget "http://spacewalk/cblr/svc/op/trig/mode/post/profile/rhel_c_5_32:1:SpacewalkDefaultOrganization" -O /dev/null
